﻿using System;
using System.IO;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;

namespace PhotoRenamer
{
    internal static class Program
    {
        private static int Main(string[] args)
        {
            var configuration = CreateHostBuilder(args).Build();
            var loggerFactory = LoggerFactory.Create(builder => builder.AddConsole());
            var logger = loggerFactory.CreateLogger(nameof(Program));
            try
            {
                var p = new Renamer(configuration, loggerFactory);
                return p.Run();
            }
            catch (Exception e)
            {
                logger.LogError(e, "Error executing program");
                return -1;
            }
        }

        public static IConfigurationBuilder CreateHostBuilder(string[] args) => new ConfigurationBuilder()
            .SetBasePath(Directory.GetCurrentDirectory())
            .AddJsonFile(AppDomain.CurrentDomain.BaseDirectory + "\\appsettings.json", optional: true,
                reloadOnChange: true)
            .AddEnvironmentVariables()
            .AddCommandLine(args);

    }
}
